package com.example.tfg;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;


public class Conf_Work_Cycle extends Activity implements View.OnClickListener
{
    private static final String TAG = Conf_Work_Cycle.class.getName();

    LinearLayout work_cycle_list, states_work_cycle;
    EditText state_time;
    Button charge_nwc, add_new_work_cycle;
    ImageButton help, back;

    ArrayList<String> states_array;

    String [] cycles; //creo una array "files" del tipo "String" en la que guardo TODOS los nombres de los ficheros encontrados
    String name_cycle_selected, time_state;

    //String que se enviaran al ESP32 cuando se vayan a escribir caracteristicas del servicio BLE
    String data_time_name;
    String data_cycle;

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________ BASE  METHODS  OF  THE  ACTIVITY ______________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.conf_work_cycle);
        init();
        fill_linear_layout_cycles();
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    @Override
    public void onClick(View view)                                                                                                                                                  // ACABADO
    {
        switch (view.getId())
        {
            case R.id.bt_charge_new_work_cycle_cwc:
                charge_new_configuration();
                break;
            case R.id.bt_add_new_work_cycle_cwc:
                go_create_new_work_cycle();
                break;
            case R.id.bt_help_cwc:
                help_of_this_activity();
                break;
            case R.id.bt_back_cwc:
                setResult(RESULT_CANCELED);
                go_device_view();
                break;

            default:
                break;
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*______________________________________________________________________ USE  THE  LINEAR  LAYOUT __________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    /*Este modulo se encarga de poblar le linear layout (rellenarlo, fill) desde los datos del la lista que se carga con anterioridad desde el fichero de texto  */
    private void fill_linear_layout_cycles()
    {
        Log.i(TAG, "Ahora vamos a mostrar los ciclos de trabajo que hay disponibles" );

        //primero, hacemos una lista de los nombres de los fihceros de texto que hay, ues cada uno se coreesponde con un ciclo de trabajo
        cycles = null;
        cycles = getApplicationContext().fileList();

//        Log.i(TAG, "Los ciclos de trabajo encontrados son: \n ");
//        for(int i = 0 ; i <cycles.length ; i++)
//            Log.i(TAG, cycles[i]);

        // Vaciamos el linear layout en caso de que hubiese alguna vista
        work_cycle_list.removeAllViewsInLayout();

        //ahora, pasamos el array de strings, 1 a 1, al linear layout correspondiente para crear las vistas con que poblar el linear layout
        for(int i = 0; i< cycles.length; i++)
        {
            // creamos una vista para cada uno de los elementos (item) encontrados, bajo la forma definida en item_ll_list_work_cycles. para ello, primero definimos los elementos de ese layout
            final View view = View.inflate(Conf_Work_Cycle.this, R.layout.item_ll_list_work_cycles, null);
            TextView index = view.findViewById(R.id.tv_index_work_cycle);
            final TextView name = view.findViewById(R.id.tv_item_name_work_cycle);

            //editamos los valores del item en el linear layout con los que acabamos de encontrar en el dispositivo bluetooth que se ha encontrado
            index.setText(String.valueOf(i));
            name.setText(cycles[i]);

            //definimos la acciones a realizar cuando hagamos click en un elemento del linear layout
            view.setOnClickListener(new View.OnClickListener()
            {
                @Override
                public void onClick(View view)
                {
                    Log.i(TAG, "Se ha pulsado en el ciclo " + name.getText().toString());
                    name_cycle_selected = name.getText().toString();
                    fill_linear_layout_states();
                }
            });

            //añadimos la vista creada al linear layout como un nuevo elemento
            runOnUiThread(new Runnable()
            {
                @Override
                public void run()
                {
                    work_cycle_list.addView(view);
                }
            });

        }

    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    /*Este modulo se encarga de poblar le linear layout (rellenarlo, fill) desde los datos del la lista que se carga con anterioridad desde el fichero de texto  */
    private void fill_linear_layout_states()                                                                                                                                        //  ACABADO
    {
        Log.i(TAG, "Ahora vamos a rellenar el linear layout con los valores de los estados" );
        //Primero he de cargar el fichero en la lista desde la que lo cargaré en la vista
        charge_file_to_list();

        // Vaciamos el linear layout en caso de que hubiese alguna vista
        states_work_cycle.removeAllViews();

        //ahora, he de poblar el linear layout
        for(int i = 0 ; i < states_array.size() ; i++)
        {
            // creamos una vista para cada uno de los elementos (item) encontrados, bajo la forma definida en item_ll_list_work_cycles. para ello, primero definimos los elementos de ese layout
            final View view = View.inflate(Conf_Work_Cycle.this, R.layout.item_ll_view_state, null);
            TextView state_text = view.findViewById(R.id.text_state_number_ll_vs);
            TextView index = view.findViewById(R.id.index_ll_vs);
            TextView state_number = view.findViewById(R.id.number_state_ll_vs);
            ImageView led_1 = view.findViewById(R.id.led1_ll_vs);
            ImageView led_2 = view.findViewById(R.id.led2_ll_vs);
            ImageView led_3 = view.findViewById(R.id.led3_ll_vs);
            ImageView led_4 = view.findViewById(R.id.led4_ll_vs);
            ImageView led_5 = view.findViewById(R.id.led5_ll_vs);
            ImageView led_6 = view.findViewById(R.id.led6_ll_vs);
            ImageView led_7 = view.findViewById(R.id.led7_ll_vs);
            ImageView led_8 = view.findViewById(R.id.led8_ll_vs);

            //editamos los valores del item en el linear layout con los que acabamos de encontrar en el dispositivo bluetooth que se ha encontrado
            index.setText(String.valueOf(i));
            state_text.setText("Estado Nº ");
            state_number.setText(String.valueOf(i));

            // Tomamlos el valor de la lista de estados, lo cargamos como un char_array y lo cargamos en el linear layout
            String state = states_array.get(i);
            char [] char_state = state.toCharArray();
            charge_state_on_linear_layout(led_1, led_2, led_3, led_4, led_5, led_6, led_7, led_8, char_state);


            //añadimos la vista creada al linear layout como un nuevo elemento
            runOnUiThread(new Runnable()
            {
                @Override
                public void run()
                {
                    states_work_cycle.addView(view);
                }
            });
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*______________________________________________________________________ WORK  WITH THE  IMAGE VIEWS _______________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void charge_state_on_linear_layout(ImageView led_1, ImageView led_2, ImageView led_3, ImageView led_4, ImageView led_5, ImageView led_6, ImageView led_7, ImageView led_8, char [] state_to_send)                                                                                                                                                      //ACABADO
    {
        Log.i(TAG, "Cargamos los leds para mostrar el estado" );
        set_image_view(led_1, 0, state_to_send);
        set_image_view(led_2, 1, state_to_send);
        set_image_view(led_3, 2, state_to_send);
        set_image_view(led_4, 3, state_to_send);
        set_image_view(led_5, 4, state_to_send);
        set_image_view(led_6, 5, state_to_send);
        set_image_view(led_7, 6, state_to_send);
        set_image_view(led_8, 7, state_to_send);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void set_image_view(final ImageView to_check, final int led_index, char [] actual_state_to_show)                                                                          //ACABADO
    {
       if(actual_state_to_show[led_index] == '1')
       {
           to_check.setBackgroundColor(getResources().getColor(R.color.button_ON));
       }
       else
       {
           to_check.setBackgroundColor(getResources().getColor(R.color.button_OFF));
       }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_____________________________________________________________________________ USE  THE  FILE _____________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    /*Este modulo se encarga de hacer una lista desde la lectura del fichero que se nos indica que debemos mostrar por pantalla desde la activity anterior  */
    private void charge_file_to_list()                                                                                                                                               //  ACABADO
    {
        // Primero dejo la lista vacía de lo que pudiese contener con atenrioridad
        states_array.clear();

        String file_to_use = name_cycle_selected;   // no hace falta añadir el ".txt" porque ya lo tomamos desde el onClickListener en el modulo "filllinear_layout_cycles"

        cycles = null;
        cycles = getApplicationContext().fileList();

        if(file_exist(cycles, file_to_use))
        {
            Log.i(TAG, "Ahora vamos a cargar los datos del fichero en una lista para poder usarlos" );
            //Toast.makeText(getApplicationContext(),"Existe el archivo", Toast.LENGTH_SHORT).show();
            try
            {
                //Toast.makeText(getApplicationContext(),"Hemos logrado entrar dentro del try", Toast.LENGTH_SHORT).show();

                //sabemos que existe el fichero, asi que trabajamos con el
                InputStreamReader used_file = new InputStreamReader(openFileInput(file_to_use)); //creo una variable de acceso al fichero
                BufferedReader buf_reader = new BufferedReader(used_file);  // Creo un lector para nuestro archivo
                String state_line = buf_reader.readLine(); // leo el archivo linea a linea, una linea por vez

                //Toast.makeText(getApplicationContext(),"La primera linea del archivo almacena: " + state_line, Toast.LENGTH_LONG).show();


                while(state_line != null)   // en caso de que el archivo no esté vacío, almacenamos lo que acabamos de leer detrás de lo que ya estaba y pasamos a la siguiente linea
                {
                    states_array.add(state_line); //añadimos el estado a la lista de estados
                    state_line = buf_reader.readLine(); // ... paso a leer la siguiente línea, y así, hasta que acabemos con todo el fichero a leer, hasta encontrar una linea vacía
                }

                //Para indicar que dejamos ya de leer, cerramos primero nuestro lector, y después nuestro archivo
                buf_reader.close();
                used_file.close();
            }
            catch (IOException e)
            {
                Log.i(TAG,"Error al intentar leer el fichero " + file_to_use);
                Toast.makeText(getApplicationContext(),"El fichero no existe", Toast.LENGTH_SHORT).show();
            }
        }
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    /* Este modulo se encarga de encontrar el fichero que se desea cargar (en caso de existir). Este módulo no requiere de llaves por tratarse de un módulo booleano, lo que permite obviar las
    llaves de apertura y cierre  */
    private boolean file_exist(String [] accessible_files, String request_file)                                                                                                      //  ACABADO
    {
        Log.i(TAG, "Buscamos el fichero de texto " + request_file);
        for(int i = 0; i< accessible_files.length; i++) //el método length nos devuelve el tamaño del array de strings "accesible_files"
            if (request_file.equals(accessible_files[i]))   // en caso de la variable "request_file" sea igual al string almacenado en la posicion [i] de accessible_files...
                return true;    // devolver "true"
        return false;   // en caso contrario, devolver "false"
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________________ PREPARE  THE  NEW  WORK  WAY __________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    public String write_time_name()                                                                                                                                                   // ACABADO
    {
        Log.i(TAG, "Vamos a crear la cadena que contiene el tiempo entre estados y el nombre del ciclo de trabajo");
        /* Aqui hemos de tener en cuenta la programacion del ESP32 en cuanto a cómo se ha definido la forma en que recibirá los datos. Por ello, hemos de seguir el patrón elegido:
            -> Primeros 4 caracteres: se corresponderán al tiempo entre estados elegido
            -> Resto de caracteres: se corresponderán con el nombre del ciclo de trabajo que se va a mostrar
        Teniendo esto en cuenta, pasamos a crear los datos que se van a escribir en la caracteristica
        */
        time_state = state_time.getText().toString();
        String to_write = new String();
        String time = new String();
        int tam = time_state.length();

        for (int i = 0 ;  i < (5 - tam) ; i++) // este bulce rellena con ceros la variable time, de modo que luego queden por delante del tiempo deseado
            time = time + "0";                  // tal que 00...time_state, hasta rellenar los 5 caracteres previstos para ello en el ESP32

        time = time + time_state;               // Ahora concatenamos las cadenas del tiempo para tener finalmente los caracteres previstos

        //Preparo el nombre del fichero de texto quitando ".txt"
        char [] char_name = name_cycle_selected.toCharArray();
        tam = name_cycle_selected.length();
        name_cycle_selected = "";
        for(int i = 0 ; i < tam - 5 ; i++)
            name_cycle_selected = name_cycle_selected + char_name[i];

        to_write = time + name_cycle_selected;  // acabamos de montar la cadena de datos que espera recibir el ESP32

        Log.i(TAG, "La cadena a enviar con los datos de tiempo y nombre es: " + to_write);
        return to_write;
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    public String write_state()                                                                                                                                                       // ACABADO
    {
        Log.i(TAG, "Vamos a crear la cadena que contiene el ciclo de trabajo");

        String to_write = "";
        char [] state_to_send;

        for(int i = 0 ; i < states_array.size() ; i++)
        {
            state_to_send = states_array.get(i).toCharArray();
            for(int j = 0 ; j<= 7 ; j++)    // este bucle for sirve para evitar enviar el salto de linea
            {
                to_write = to_write + state_to_send[j];
            }
            Log.i(TAG, "la cadena actual es: " + to_write);
        }

        Log.i(TAG, "La cadena a enviar con los datos de tiempo y nombre es: " + to_write);
        return to_write;
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________________ CONTROL  THE  BUTTONS _________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void charge_new_configuration()                                                                                                                                           // ACABADO
    {
        Log.i(TAG, "Vamos a pasar los datos a la activity padre, pues el usuario ha decidido cargar la configuracion");

        //almaceno los string a enviar a la activity padre
        data_time_name = write_time_name();
        data_cycle = write_state();
        Log.i(TAG, "Los datos que vamos a pasar son: \n tiempo y nombre: \n" + data_time_name + "\n y estados a mostrar: \n" + data_cycle );


        //creo un intent para poder enviar los strings usando putExtra-getExtra
        Intent send_strings = new Intent();
        send_strings.putExtra("TIME_NAME", data_time_name);  //  "TIME_NAME"
        send_strings.putExtra("CYCLE", data_cycle);



        // Finalmente, paso el intent con los datos a recuperar en la activity padre
        setResult(RESULT_OK, send_strings);
        go_device_view();
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void go_device_view()                                                                                                                                                     // ACABADO
    {
        finish();
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void go_create_new_work_cycle()                                                                                                                                           // ACABADO
    {
        //AMBOS CODIGOS SON VALIDOS, PERO VAMOS A USAR EL SUPERIOR PARA GANAR CLARIDAD EN EL CODIGO

        Log.i(TAG, "vamos a la activity para crear un nuevo estado" );
        Intent create_work_cycle = new Intent(Conf_Work_Cycle.this, Create_New_Work_Cycle.class);//desde la ventana en que estoy, a la que quiero llegar
        startActivityForResult(create_work_cycle, 11223344);//llamo a la otra ventana usando el parámetro intent que nos lleva de una a otra, como si de un camino se tratase
//        startActivityForResult((new Intent(Conf_Work_Cycle.this, Create_New_Work_Cycle.class)));
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void help_of_this_activity()
    {
        //AMBOS CODIGOS SON VALIDOS, PERO VAMOS A USAR EL INFERIOR PARA EVITAR TENER OTRA VARIABLE EN JUEGO

        // Intent youtube_help = new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v=9-3OCc5g5oE"));//desde la ventana en que estoy, a la que quiero llegar
        // startActivity(youtube_help);
        startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v=9-3OCc5g5oE")));
        // Toast.makeText(this, "Hemos pasado por la parte de ir a youtube",Toast.LENGTH_SHORT).show(); // Los "toast" que uso son solo para verificacion de por donde llega el codigo en ejecucion
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*___________________________________________________________________________ METODH  ON  RESULT ___________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        Log.i(TAG, "onAvtivityResult");
        switch (requestCode)
        {
            case 11223344:
                Log.i(TAG, "onAvtivityResult --> Volvemos desde crear un nuevo ciclo de trabajo");
                switch (resultCode)
                {
                    case RESULT_OK:
                        //Como se ha añadido correctamente un nuevo ciclo de trabajo, debemos recargar la lista de ciclos de trabajo y después, se gestionará su uso como antes.
                        fill_linear_layout_cycles();
                        break;
                    case RESULT_CANCELED:
                        Log.i(TAG, "No se ha decidido configurar un nuevo trabajo");
                }
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_________________________________________________________________________ PREPARE  THE  ACTIVITY _________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void prepare_buttons()                                                                                                                                                      //ACABADO
    {
        Log.i(TAG, "Preparamos los botones para usarlos" );
        add_new_work_cycle.setOnClickListener(this);
        charge_nwc.setOnClickListener(this);
        back.setOnClickListener(this);
        help.setOnClickListener(this);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void init()                                                                                                                                                               //  ACABADO
    {
        work_cycle_list = findViewById(R.id.ll_cycles_cwc);
        states_work_cycle = findViewById(R.id.ll_states_of_cycle_cwc);

        state_time = findViewById(R.id.et_state_time_cwc);

        charge_nwc = findViewById(R.id.bt_charge_new_work_cycle_cwc);
        add_new_work_cycle = findViewById(R.id.bt_add_new_work_cycle_cwc);

        back = findViewById(R.id.bt_back_cwc);
        help = findViewById(R.id.bt_help_cwc);

        prepare_buttons();

        cycles = null;
        cycles = getApplicationContext().fileList();

        states_array = new ArrayList<>();
    }
}
