package com.example.tfg;

/* Esta clase será usada para gestionar cómo crear los nuevos estados de un ciclo de trabajo  incluirlos
 en el listView del mismo. Por ello, conecta con la activity "create_new_state" y todas las variables de
 esta llevan el sufijo de la misma "_cns"                                                              */

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import java.io.File;
import java.io.IOException;
import java.io.OutputStreamWriter;

public class Create_New_State extends Activity implements View.OnClickListener                                                                                                          //ACABADO
{

    private static final String TAG = Create_New_State.class.getName();

    //Variables referentes a los objetos visibles en el layout
    TextView number_cns, state_number;
    ToggleButton led_1, led_2, led_3, led_4, led_5, led_6, led_7, led_8;
    Button  add, discard;
    ImageButton back, help;

    // Variable en que almacenaré el estado completo para escribirlo en el fichero
    String work_cycle_file;

    //Variable que almacenará en cada instante los cambios que efctue el usuario sobre el estado que está editando
    String [] state_on_work = {"0","0","0","0","0","0","0","0"}; //inicializo el estado con todos los led appagados


    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*________________________________________________________________________ BASE  METHODS  OF  THE  ACTIVITY ________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    @Override
    public void onCreate(Bundle savedInstanceState)                                                                                                                                     //ACABADO
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.create_new_state);

        //Inicializamos todos los elementos visibles del activity
        init();

        check_state_tb();// Llamo a la comprobacion de los estados de los led
    }

    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    @Override
    public void onClick(View view)                                                                                                                                                      //ACABADO
    {
        switch (view.getId())
        {
            case R.id.bt_accept_cns:
                save_new_state();
                break;
            case R.id.bt_refuse_cns:
                discard_new_state();
                break;
            case R.id.bt_back_cns:
                setResult(RESULT_CANCELED);
                go_create_new_work_cycle();
                break;
            case R.id.bt_help_cns:
                help_of_this_activity();
            default:
                break;
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*________________________________________________________________________ CONTROL  THE  TOGGLE  BUTTONS ___________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void check_state_tb()                                                                                                                                                      //ACABADO
    {
        Log.i(TAG, "Comprobamos el estado de los ToggleButtons");
        set_state_tb(led_1, 0);
        set_state_tb(led_2, 1);
        set_state_tb(led_3, 2);
        set_state_tb(led_4, 3);
        set_state_tb(led_5, 4);
        set_state_tb(led_6, 5);
        set_state_tb(led_7, 6);
        set_state_tb(led_8, 7);
    }

    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    /* Este módulo se encarga de comprobar el estado de un ToggleButton (tb ó TB) y llamar a la funcion
    encargada de darles el color de fondo (background) que se desea para marcar su estado como"ON" u "OFF",
    pasándo dicho color como parámetro.                                                                 */
    private void set_state_tb(final ToggleButton to_check, final int led_index)                                                                                                       //ACABADO
    {
        Log.i(TAG, "Ponemos el estado de los ToggleButtons");
        to_check.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener()    //hacemos invocacion del nuevo metodo setOnCheckedChangeListener, creando un "OnCheckedChangeListener" nuevo
        {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean state_tb)
            {
                if(state_tb)
                {   // R-->recurso, color--> tipo recurso,  button_ON --> color recurso a usar
                    //change_led_color(R.color.button_ON, to_check);
                    to_check.setBackgroundColor(getResources().getColor(R.color.button_ON));
                    /*
                    esto tambien podría hacerse tal que:
                        to_check.setBackgroundcolor(ContextCompact.getColor(detBaseContext(),R.color.button_ON)
                    en vez de haciendo una llamada al modulo que hemos diseñado para ello
                    */

                    //Ahora, guardamos el valor del boton a cadena que almacena el estado
                    state_on_work[led_index] = "1";

                    //Toast.makeText(getApplicationContext(),"El led " + led_index +" está a 1", Toast.LENGTH_SHORT).show();
                }
                else
                {   /* R-->recurso, color--> tipo recurso,  button_OFF --> color recurso a usar
                    Cabe decir que R hace uso de los recursos del paquete en que estamos. En caso
                    de querer hacer uso de recursos de otro paquete, sería xxx.R.yyy, donde xxx
                    haría referencia al paquete del que queremos hacer uso del recurso yyy */
                    //change_led_color(R.color.button_OFF,to_check);
                    to_check.setBackgroundColor(getResources().getColor(R.color.button_OFF));

                    //Ahora, guardamos el valor del boton a cadena que almacena el estado
                    state_on_work[led_index] = "0";
                    //Toast.makeText(getApplicationContext(),"El led " + led_index +" está a 0", Toast.LENGTH_SHORT).show();
                }
            }
        });
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________________ CONTROL  THE  BUTTONS _________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void save_new_state()                                                                                                                                                       //ACABADO
    {
        Log.i(TAG, "Pasamos a guardar el valor del nuevo estado en el ciclo de trabajo");
        //creo un string para almacenar en el string array como si fuese 1 único string, para poder escribirlo correctamente en el fichero de texto
        String state_to_save = "";


        /*  Esto que está comentado también sirve para introducir los 8 valores que contiene el char array "state_on_work"      */
        for(String s: state_on_work)
        {
            state_to_save += s;
        }
        Log.i(TAG, "El estado a guardar es " + state_to_save);

        //Toast.makeText(getApplicationContext(),"La cadena a guardar es " + state_to_save, Toast.LENGTH_LONG).show();

        //Ahora creo el acceso a un archivo que quiero escribir, dentro del try-catch requerido para ello
        Log.i(TAG, "Pasamos a abrir/crear el fichero de texto: " + work_cycle_file);
        try
        {
            String file_to_open = work_cycle_file + ".txt";
            OutputStreamWriter edit_file = new OutputStreamWriter(openFileOutput(file_to_open, getApplicationContext().MODE_APPEND));    //El modo APPEND abre un fich y escribe al final, o en caso de no existir, lo crea y escribe
            // con ello ya abierto, escribo al final del fichero el nuevo estado del ciclo de trabajo
            edit_file.write(state_to_save + "\n");
            //ahora, limpio el canal de escritura para prepararlo para el siguiente uso
            edit_file.flush();
            //finalmente, cierro el fichero
            edit_file.close();
            setResult(RESULT_OK);
        }
        catch(IOException e)
        {
            Log.e("Writte File Error","Error al intentar escribir en el fichero " + work_cycle_file + e.getMessage());
            setResult(RESULT_CANCELED);
        }
        // Toast.makeText(getApplicationContext(),"Ya hemos guardado los cambios en el fichero ", Toast.LENGTH_SHORT).show();
        go_create_new_work_cycle();
    }

    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void discard_new_state()                                                                                                                                                    //ACABADO
    {
        // Volvemos a la activity que nos trajo, SIN GUARDAR los cambios y extras que hemos realizado pero hemos decidido descartar
        setResult(RESULT_CANCELED);
        go_create_new_work_cycle();
    }

    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    public void go_create_new_work_cycle()                                                                                                                              //ACABADO
    {
        Log.i(TAG, "Volvemos a la activity padre");
        // Como podemos preveer el resultado de la activity, la acabamos para evitar que siga consumiendo recursos por quedar en la pila de activitys, de modo que devolvemos una señal de que
        // el trabajo ha sido realizado como se esperaba, y finalizamos esta activity en vez de hacer un startActivity que nos devuelva a la actividad padre
        finish();
    }

    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void help_of_this_activity()                                                                                                                                                //ACABADO
    {
        //AMBOS CODIGOS SON VALIDOS, PERO VAMOS A USAR EL INFERIOR PARA EVITAR TENER OTRA VARIABLE EN JUEGO

        // Intent youtube_help = new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v=9-3OCc5g5oE"));//desde la ventana en que estoy, a la que quiero llegar
        // startActivity(youtube_help);
        startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v=9-3OCc5g5oE")));
        // Toast.makeText(this, "Hemos pasado por la parte de ir a youtube",Toast.LENGTH_SHORT).show(); // Los "toast" que uso son solo para verificacion de por donde llega el codigo en ejecucion
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_______________________________________________________________________________ PREPARE  THE  ACTIVITY ___________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    //Este modulo se encarga de tomar los datos que se envian desde la activity padre
    private void take_data()                                                                                                                                                         //  ACABADO
    {
        Log.i(TAG, "Recogemos los datos que se nos pasan desde la activity padre (Device_View), es decir, el nombre del fich a modificar/crear " );
        work_cycle_file = getIntent().getStringExtra("CYCLE_NAME"); // recuperamos el valor del fichero que nos comparte la activity que invoca esta
        Log.i(TAG, "Lo recibido es " + work_cycle_file);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void prepare_buttons()                                                                                                                                                      //ACABADO
    {
        Log.i(TAG, "Preparamos los botones tipo BUTTON");
        // Defino los metodos sobre los botones
        add.setOnClickListener(this);
        discard.setOnClickListener(this);
        back.setOnClickListener(this);
        help.setOnClickListener(this);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void init()                                                                                                                                                                 //ACABADO
    {

        Log.i(TAG, "Inicializamos la activity");
        number_cns = findViewById(R.id.tv_number_cns);
        state_number = findViewById(R.id.tv_state_cns);

        led_1 = findViewById(R.id.tb_led_1_cns);
        led_2 = findViewById(R.id.tb_led_2_cns);
        led_3 = findViewById(R.id.tb_led_3_cns);
        led_4 = findViewById(R.id.tb_led_4_cns);
        led_5 = findViewById(R.id.tb_led_5_cns);
        led_6 = findViewById(R.id.tb_led_6_cns);
        led_7 = findViewById(R.id.tb_led_7_cns);
        led_8 = findViewById(R.id.tb_led_8_cns);

        add = findViewById(R.id.bt_accept_cns);
        discard = findViewById(R.id.bt_refuse_cns);

        back = findViewById(R.id.bt_back_cns);
        help = findViewById(R.id.bt_help_cns);

        work_cycle_file = new String();     // lo inicializo vacío

        prepare_buttons();

        take_data();

    }
}
