package com.example.tfg;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;

/* Esta clase será usada para poder crear nuevos ciclos de trabajo que se añadan en la lista de ciclos de
trabajo existentes para cargar en el controlador, es decir, serán los que formen los item de la listView
del activity "conf_work_cycle". Así mismo, esta clase está plenamente relacionada con el activity
 "create_new_work_cycle", de modo que el resto de gestiones del mismo se harán desde aquí, y por ello,
 el sufijo de los botones a los que se accede es "_cnwc"                                              */


public class Create_New_Work_Cycle extends Activity implements View.OnClickListener
{

    private static final String TAG = Create_New_Work_Cycle.class.getName();

    //Variables referentes a los objetos visibles en el layout
    EditText name_work_cycle;
    LinearLayout states;
    Button add_new_state, discard, save;
    ImageButton back, help;

    //Variable que almacenará el nombre que queremos dar al ciclo de trabajo y otra para comprobar que existe
    String cycle_name;
    String cycles []; //creo una array "files" del tipo "String" en la que guardo TODOS los nombres de los ficheros encontrados

    // Variable para acceder a los diferentes estados del ciclo de trabajo
     ArrayList<String> states_for_work_cycle;

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________ BASE  METHODS  OF  THE  ACTIVITY ______________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.create_new_work_cycle);
        init();
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    @Override
    public void onClick(View view)                                                                                                                                                  //  ACABADO
    {
        switch (view.getId())
        {
            case R.id.bt_add_new_state_cnwc:
                go_add_new_state();
                break;
            case R.id.bt_save_cnwc:
                save_new_work_cycle();
                break;
            case R.id.bt_deny_cnwc:
                discard_new_work_cycle();
                break;
            case R.id.bt_back_cnwc:
                setResult(RESULT_CANCELED);
                go_conf_work_cycle();
                break;
            case R.id.bt_help_cnwc:
                help_of_this_activity();
                break;
            default:
                break;
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*______________________________________________________________________ USE  THE  LINEAR  LAYOUT __________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    /*Este modulo se encarga de poblar le linear layout (rellenarlo, fill) desde los datos del la lista que se carga con anterioridad desde el fichero de texto  */
    private void fill_linear_layout()                                                                                                                                                //  ACABADO
    {
        Log.i(TAG, "Rellenamos el linearlayout con los datos del fichero: " + cycle_name);
        //Primero he de cargar el fichero en la lista desde la que lo cargaré en la vista
        charge_file_to_list();

        clean_linear_layout();

        //ahora, he de poblar el linear layout, de modo que....
        for(int i = 0 ; i < states_for_work_cycle.size() ; i++)
        {

            // Primero creamos una vista para cada uno de los elementos (item) encontrados, bajo la forma definida en item_ll_list_work_cycles. para ello, primero definimos los elementos de ese layout
            final View view = View.inflate(Create_New_Work_Cycle.this, R.layout.item_ll_view_state, null);
            TextView state_text = view.findViewById(R.id.text_state_number_ll_vs);
            TextView index = view.findViewById(R.id.index_ll_vs);
            TextView state_number = view.findViewById(R.id.number_state_ll_vs);
            ImageView led_1 = view.findViewById(R.id.led1_ll_vs);
            ImageView led_2 = view.findViewById(R.id.led2_ll_vs);
            ImageView led_3 = view.findViewById(R.id.led3_ll_vs);
            ImageView led_4 = view.findViewById(R.id.led4_ll_vs);
            ImageView led_5 = view.findViewById(R.id.led5_ll_vs);
            ImageView led_6 = view.findViewById(R.id.led6_ll_vs);
            ImageView led_7 = view.findViewById(R.id.led7_ll_vs);
            ImageView led_8 = view.findViewById(R.id.led8_ll_vs);

            //editamos los valores del item en el linear layout con los que acabamos de encontrar en el dispositivo bluetooth que se ha encontrado
            index.setText(String.valueOf(i));
            state_text.setText("Estado Nº ");
            state_number.setText(String.valueOf(i));

            String state = states_for_work_cycle.get(i);
            char [] char_state = state.toCharArray();
            charge_state_on_linear_layout(led_1, led_2, led_3, led_4, led_5, led_6, led_7, led_8, char_state);

            //añadimos la vista creada al linear layout como un nuevo elemento
            runOnUiThread(new Runnable()
            {
                @Override
                public void run()
                {
                    states.addView(view);
                }
            });
        }
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void clean_linear_layout()                                                                                                                                               //  ACABADO
    {
        Log.i(TAG, "Borramos todas las vistas del linear layout antes de proceder a la carga de todos los estados desde cero");
        states.removeAllViewsInLayout();
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*______________________________________________________________________ WORK  WITH THE  IMAGE VIEWS _______________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void charge_state_on_linear_layout(ImageView led_1, ImageView led_2, ImageView led_3, ImageView led_4, ImageView led_5, ImageView led_6, ImageView led_7, ImageView led_8, char [] state_to_send)                                                                                                                                                      //ACABADO
    {
        Log.i(TAG, "Cargamos las vistas de los led");
        set_image_view(led_1, 0, state_to_send);
        set_image_view(led_2, 1, state_to_send);
        set_image_view(led_3, 2, state_to_send);
        set_image_view(led_4, 3, state_to_send);
        set_image_view(led_5, 4, state_to_send);
        set_image_view(led_6, 5, state_to_send);
        set_image_view(led_7, 6, state_to_send);
        set_image_view(led_8, 7, state_to_send);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void set_image_view(final ImageView to_check, final int led_index, char [] actual_state_to_show)                                                                           //ACABADO
    {
        Log.i(TAG, "Cargamos la imagen del led: " + led_index);
        if(actual_state_to_show[led_index] == '1')
        {
            to_check.setBackgroundColor(getResources().getColor(R.color.button_ON));
        }
        else
        {
            to_check.setBackgroundColor(getResources().getColor(R.color.button_OFF));
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_____________________________________________________________________________ USE  THE  FILE _____________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    /*Este modulo se encarga de hacer una lista desde la lectura del fichero que se nos indica que debemos mostrar por pantalla desde la activity anterior  */
    private void charge_file_to_list()                                                                                                                                               //  ACABADO
    {
        String file_to_use = cycle_name + ".txt";
        cycles = null;  //limpiamos el array de ficheros que hay en la app para poder actualiarlo
        cycles = getApplicationContext().fileList();    // actualizamos los ficheros que hay en la app

//        Log.i(TAG, "los ficheros encontrados son: \n");
//        for(int i = 0; i < cycles.length; i++)
//            Log.i(TAG,cycles[i]);

        states_for_work_cycle.clear();// Vaciamos la lista de estados

        if(file_exist(cycles, (cycle_name + ".txt")))
        {
            Log.i(TAG, "Ahora vamos a cargar los datos del fichero en una lista para poder usarlos" );
            //Toast.makeText(getApplicationContext(),"Existe el archivo", Toast.LENGTH_SHORT).show();
            try
            {
                Toast.makeText(getApplicationContext(),"Hemos logrado entrar dentro del try", Toast.LENGTH_SHORT).show();

                //sabemos que existe el fichero, asi que trabajamos con el
                InputStreamReader used_file = new InputStreamReader(openFileInput(cycle_name + ".txt")); //creo una variable de acceso al fichero
                BufferedReader buf_reader = new BufferedReader(used_file);  // Creo un lector para nuestro archivo
                String state_line = buf_reader.readLine(); // leo el archivo linea a linea, una linea por vez

                //Toast.makeText(getApplicationContext(),"La primera linea del archivo almacena: " + state_line, Toast.LENGTH_LONG).show();

                while(state_line != null)   // en caso de que el archivo no esté vacío, almacenamos lo que acabamos de leer detrás de lo que ya estaba y pasamos a la siguiente linea
                {
                    states_for_work_cycle.add(state_line); //añadimos el estado a la lista de estados
                    state_line = buf_reader.readLine(); // ... paso a leer la siguiente línea, y así, hasta que acabemos con todo el fichero a leer, hasta encontrar una linea vacía
                }

                //Para indicar que dejamos ya de leer, cerramos primero nuestro lector, y después nuestro archivo
                buf_reader.close();
                used_file.close();
                Log.i(TAG,"Hemos acabado de leer el fichero " + file_to_use);
            }
            catch (IOException e)
            {
                Log.i(TAG,"Error al intentar leer el fichero " + file_to_use);
                Toast.makeText(getApplicationContext(),"El fichero no existe", Toast.LENGTH_SHORT).show();
            }
        }
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    /* Este modulo se encarga de encontrar el fichero quese desea cargar (en caso de existir)      */
    private boolean file_exist(String accessible_files [], String request_file)                                                                                                      //  ACABADO
    {
        Log.i(TAG, "Buscamos el fichero de texto " + request_file);
        for(int i = 0; i < accessible_files.length; i++) //el método length nos devuelve el tamaño del array de strings "accesible_files"
            if (request_file.equals(accessible_files[i]))   // en caso de la variable "request_file" sea igual al string almacenado en la posicion [i] de accessible_files...
            {
                Log.i(TAG, "Se ha encontrado el fichero deseado !!! ");
                return true;    // devolver "true"
            }
        return false;   // en caso contrario, devolver "false"
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________________ CONTROL  THE  BUTTONS _________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void discard_new_work_cycle()                                                                                                                                            //  ACABADO
    {
        Log.i(TAG, "Descartamos el nuevo ciclo de trabajo");
        // Es aqui donde hemos de eliminar el fichero de texto en caso de que el usuario desee descartar el ciclo de trabajo que está creando

        cycles = null;
        cycles = getApplicationContext().fileList();

        String file_to_find = cycle_name + ".txt";
        if(file_exist(cycles,(cycle_name + ".txt")))
        {
            if(getApplicationContext().deleteFile(file_to_find))
                Log.i(TAG, "Se ha eliminado correctamente el fichero descartado");
        }

        //Finalmente, volvemos a la activity padre
        setResult(RESULT_OK);
        go_conf_work_cycle();
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void save_new_work_cycle()                                                                                                                                              //  ACABADO
    {
        Log.i(TAG, "Guardamos el nuevo ciclo de trabajo");
        // Como todas las gestiones del fichero de texto se hacen en "Create_New_State", no hace falta que toquemos nada aqui
        setResult(RESULT_OK);
        go_conf_work_cycle();
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void go_add_new_state()                                                                                                                                                 //  ACABADO
    {
        cycle_name = name_work_cycle.getText().toString();

        cycles = null;
        cycles = getApplicationContext().fileList();

        //Primero vamos a crear el fichero que vamos a trabajar
        String file_to_create = cycle_name + ".txt";
        if(file_exist(cycles, (cycle_name + ".txt")))
            Log.i(TAG, "El fichero ya existe, de modo que no hace falta crearlo ");
        else
        {
            try
            {
                OutputStreamWriter new_file = new OutputStreamWriter(openFileOutput(file_to_create, getApplicationContext().MODE_PRIVATE));
                new_file.close();
                cycles = null;
                cycles = getApplicationContext().fileList();

                if(file_exist(cycles, (cycle_name + ".txt")))
                    Log.i(TAG, "Se ha creado correctamente el fichero " + file_to_create);
            }
            catch (IOException e)
            {
                Log.i(TAG, "NO se ha logrado crear el fichero " + file_to_create);
            }
        }

        Log.i(TAG, "Vamos a la activity 'Create_New_State' ");
        //Ahora, volvemos a la activity que nos trajo, SIN GUARDAR los cambios y extras que hemos realizado pero hemos decidido descartar
        Intent create_new_state = new Intent(Create_New_Work_Cycle.this, Create_New_State.class);
        create_new_state.putExtra("CYCLE_NAME", cycle_name);
        Log.i(TAG, "Lo que se envia es: " + cycle_name);
        startActivityForResult(create_new_state, 11223300);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void go_conf_work_cycle()                                                                                                                                                //  ACABADO
    {
        Log.i(TAG, "Volvemos a la activity padre");
        finish();
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void help_of_this_activity()
    {
        //AMBOS CODIGOS SON VALIDOS, PERO VAMOS A USAR EL INFERIOR PARA EVITAR TENER OTRA VARIABLE EN JUEGO

        // Intent youtube_help = new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v=9-3OCc5g5oE"));//desde la ventana en que estoy, a la que quiero llegar
        // startActivity(youtube_help);
        startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v=9-3OCc5g5oE")));
        //Toast.makeText(this, "Hemos pasado por la parte de ir a youtube",Toast.LENGTH_SHORT).show(); // Los "toast" que uso son solo para verificacion de por donde llega el codigo en ejecucion
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_____________________________________________________________________________ RESULT CASES _______________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data)                                                                                                     //  ACABADO
    {
        Log.i(TAG, "onAvtivityResult");
        switch (requestCode)
        {
            case 11223300:
                Log.i(TAG, "onAvtivityResult --> Volvemos desde crear un nuevo estado para el ciclo de trabajo");
                switch (resultCode)
                {
                    case RESULT_OK:
                        //Como se ha añadido correctamente un estado en el ciclo de trabajo, debemos recargar la vista en el linearlayout. Para ello, primero hemos de limpiarlo
                        fill_linear_layout();
                        break;
                    case RESULT_CANCELED:
                        Log.i(TAG, "No se ha añadido ninún nuevo estado");
                }
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_________________________________________________________________________ PREPARE  THE  ACTIVITY _________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void prepare_buttons()                                                                                                                                                    //  ACABADO
    {
        Log.i(TAG, "Preparamos los botones");
        add_new_state.setOnClickListener(this);
        discard.setOnClickListener(this);
        save.setOnClickListener(this);
        back.setOnClickListener(this);
        help.setOnClickListener(this);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void init()                                                                                                                                                               //  ACABADO
    {
        Log.i(TAG, "Inicializamos la Activity");
        name_work_cycle = findViewById(R.id.et_work_cycle_name_cnwc);

        states = findViewById(R.id.ll_states_cnwc);

        add_new_state = findViewById(R.id.bt_add_new_state_cnwc);
        save = findViewById(R.id.bt_save_cnwc);
        discard = findViewById(R.id.bt_deny_cnwc);

        back = findViewById(R.id.bt_back_cnwc);
        help = findViewById(R.id.bt_help_cnwc);

        prepare_buttons();

        cycle_name = "default";  //damos un nombre por defecto al fichero

        states_for_work_cycle = new ArrayList<>();

        cycles = getApplicationContext().fileList();
    }
}
