package com.example.tfg;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothGatt;
import android.bluetooth.BluetoothGattCallback;
import android.bluetooth.BluetoothGattCharacteristic;
import android.bluetooth.BluetoothGattService;
import android.bluetooth.BluetoothManager;
import android.bluetooth.BluetoothProfile;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.UUID;

public class Device_View extends Activity implements View.OnClickListener
{
    private static final String TAG = Device_View.class.getName();

    //Variables referentes a los elementos visuales de la activity
    TextView device_name, state_time;
    Button conf_device, cycle_on_work;
    ToggleButton connection;
    ImageButton help, back;
    ImageView state_device, led1, led2, led3, led4, led5, led6, led7, led8;

    BluetoothDevice device;

    String cycle_on_work_name;
    String time_name, cycle;

    BroadcastReceiver broadcastReceiver;
    BluetoothGatt gatt_to_use;

    boolean keep_reading = true;

    //Variable que usaré para trabajar con las características encontradas en los diferentes servicios
    ArrayList<BluetoothGattCharacteristic> characteristics;

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_________________________________________________________________ MANAGEMENT  THE  BLE  GATT  CALLBACKS __________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    BluetoothGattCallback generalGatt = new BluetoothGattCallback()                                                                                                                   //  ACABADO
    {
        //acciones a realizar según el estado de conexión entre los dispositivos
        @Override
        public void onConnectionStateChange(final BluetoothGatt gatt, int status, int newState)
        {
            gatt_to_use = gatt;
            super.onConnectionStateChange(gatt, status, newState);
            Log.i(TAG, "status " + status + "\tnewState " + newState);
            switch (newState)
            {
                case BluetoothGatt.STATE_CONNECTED: //si el dispositivo está conectado...
                    connection.setText("Conectado");
                    Log.i(TAG, " Hemos dado con un dispositivo con el que estamos conectados ");
                    gatt.discoverServices();    //descubrimos los servicios que posee para poder hacer uso de ellos
                    runOnUiThread(new Runnable()    //Gestionamos la visibilidad de los elementos de la pantalla (activity)
                    {
                        @Override
                        public void run()
                        {
                            visibility_of_elements();
                        }
                    });
                    runOnUiThread(new Runnable()
                    {
                        @Override
                        public void run()
                        {
                            // Creamos un elemento para
                            (new Handler()).postDelayed(new Runnable()
                            {
                                @Override
                                public void run()
                                {
                                    if (
                                            getCharacteristicFromUUID(Constants.UUID_NAME_READ) != null
                                            && getCharacteristicFromUUID(Constants.UUID_TIME_READ) != null
                                            && getCharacteristicFromUUID(Constants.UUID_STATE_READ) != null
                                        )
                                    {
                                        gatt.readCharacteristic(getCharacteristicFromUUID(Constants.UUID_NAME_READ));
                                    }
                                }
                            }, 7 * 1000);
                        }
                    });
                    break;

                case BluetoothProfile.STATE_DISCONNECTED:
                    Log.i(TAG, " Hay un dispositivo y NO estamos conectados a el");
                    state_time.setText(" ");
//                    cycle_on_work.setText(" ");
                    invisibility_for_elements();
                    gatt.close();
                    break;
                default:
                    gatt.getDevice().connectGatt(Device_View.this, false, this);
                    Log.i(TAG, "Otro estado distinto en onConnectionStateChange:" + status + " to " + newState);
                    invisibility_for_elements();
                    gatt.close();
            }
        }

        //acciones a realizar en función de los servicios descubiertos
        @Override
        public void onServicesDiscovered(BluetoothGatt gatt, int status)
        {
            super.onServicesDiscovered(gatt, status);
            //creamos una lista con los servicios que se van encontrando para el dispositivo
            ArrayList<BluetoothGattService> services = new ArrayList<>(gatt.getServices());

            //para cada uno de los servicios encontrados, buscamos todas sus características
            for (BluetoothGattService service : services) //definimos una variable del tipo que queremos recorrer y cuantas veces la queremos recorrer
            {
                characteristics.addAll(service.getCharacteristics()); //descubrimos las características del servicio y las ñadimos a la lista "characteristics"
                String a = "";
                for (BluetoothGattCharacteristic c : characteristics)
                    a += c.getUuid().toString() + "\n";
                String b = "";
                b = service.getUuid().toString();
                Log.i(TAG, " Hemos descubierto las características del servicio \n" + b + "\n y dichas caracteristicas son \n" + a);
            }
        }

        //
        @Override
        public void onCharacteristicRead(final BluetoothGatt gatt, BluetoothGattCharacteristic characteristic, int status)
        {
            Log.i(TAG, "Caracteristica leida " + characteristic.getUuid().toString());
            switch (characteristic.getUuid().toString())
            {
                case Constants.UUID_NAME_READ:
                    fill_cycle_name(characteristic.getStringValue(0));  // Tomo el nombre del ciclo y lo muestro en esta activity con el modulo "fill_cycle_name"
                    gatt.readCharacteristic(getCharacteristicFromUUID(Constants.UUID_TIME_READ));// y ahora paso a llamar el siguiente trabajo a hacer, en este caso, leer la caracteristica del tiempo
                    break;
                case Constants.UUID_TIME_READ:
                    fill_state_time(characteristic.getStringValue(0));  // Ahora tomo el tiempo entre estados y lo muestro en la activity
                    gatt.readCharacteristic(getCharacteristicFromUUID(Constants.UUID_STATE_READ));  // y paso a gesstionar la siguiente lectura
                    break;
                case Constants.UUID_STATE_READ:
                    fill_leds_state(characteristic.getStringValue(0));  // Leo la caracteristica referente al estado actual...
                    if(keep_reading)
                        gatt.readCharacteristic(getCharacteristicFromUUID(Constants.UUID_STATE_READ));// y paso a volver a leer la siguiente, para que se actualice constantemente en caso de cambiar en el ESP32
            }
        }

        @Override
        public void onCharacteristicWrite(BluetoothGatt gatt , BluetoothGattCharacteristic characteristic , int status)
        {
            Log.i(TAG , "Vamos a escribir en las características previstas para ello");
            switch (characteristic.getUuid().toString())
            {
                case Constants.UUID_NAME_TIME_WRITE:
                    keep_reading = true;
                    gatt.writeCharacteristic(getCharacteristicFromUUID(Constants.UUID_STATE_WRITE));
                    break;
                case Constants.UUID_STATE_WRITE:
                    Toast.makeText(Device_View.this, "Enviado", Toast.LENGTH_SHORT).show();
                    gatt_to_use.readCharacteristic(getCharacteristicFromUUID(Constants.UUID_NAME_READ));
                    break;
            }
        }
    };

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________ BASE  METHODS  OF  THE  ACTIVITY ______________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    @Override
    public void onCreate(Bundle savedInstanceState)                                                                                                                                   //  ACABADO
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.device_view);
        init();
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    @Override
    public void onClick(View view)                                                                                                                                                   //  ACABADO
    {
        Log.i(TAG, "button clicked " + view.getId());
        switch (view.getId())
        {
            case R.id.bt_help_ad:
                help_of_this_activity();
                break;
            case R.id.bt_back_dv:
                go_accessible_devices();
                break;
            case R.id.bt_conf_work_cycle_dv:
                go_conf_work_cycle();
                break;
            case R.id.bt_cycle_on_work_dv:
                go_view_cycle_on_work();
                break;
            default:
                break;
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_____________________________________________________________________________ OTHER  MODULES _____________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void readStuff(BluetoothAdapter adapter, BluetoothDevice device)                                                                                                         //  ACABADO
    {
        unregisterReceiver(broadcastReceiver);
        adapter.cancelDiscovery();
        device.connectGatt(Device_View.this, false, generalGatt);
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*________________________________________________________________________ CHARACTERISTICS  MANAGEMENT _____________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private BluetoothGattCharacteristic getCharacteristicFromUUID(String uuid)
    {
        Log.i(TAG, "Intentando encontrar la caracteristica con UUID: " + uuid);
        for (BluetoothGattCharacteristic characteristic : characteristics)
        {
            if (characteristic.getUuid().toString().equals(uuid))
            {
                Log.i(TAG, "Se ha encontado la caracteristica con UUID: " + uuid);
                return characteristic;
            }
        }
        return null;
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*___________________________________________________________________________ EDIT  THE  LEDS  STATE _______________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void set_image_view(final ImageView to_check, final int led_index, char [] actual_state_to_show)                                                                         //  ACABADO
    {
        if(actual_state_to_show[led_index] == '1')
        {
            to_check.setBackgroundColor(getResources().getColor(R.color.button_ON));
        }
        else
        {
            to_check.setBackgroundColor(getResources().getColor(R.color.button_OFF));
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________________ LOAD  THE  READED  DATA _______________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void fill_cycle_name(String value)                                                                                                                                        //  ACABADO
    {
        Log.i(TAG, "Escribimos el nombre del ciclo: " + value);
        cycle_on_work_name = value.toLowerCase();
        cycle_on_work.setText(value);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void fill_leds_state(String data)                                                                                                                                         //  ACABADO
    {
        Log.i(TAG, "Escribimos el estado actual es: " + data);
        char [] leds_state_array;
        leds_state_array = data.toCharArray();
//        for(int i = 0 ; i<= 7; i++)
//        {
//            Log.i(TAG, "El valor del indice " + i + " del array de estados de los led es: " + leds_state_array[i]);
//        }
        set_image_view(led1, 0, leds_state_array);
        set_image_view(led2, 1, leds_state_array);
        set_image_view(led3, 2, leds_state_array);
        set_image_view(led4, 3, leds_state_array);
        set_image_view(led5, 4, leds_state_array);
        set_image_view(led6, 5, leds_state_array);
        set_image_view(led7, 6, leds_state_array);
        set_image_view(led8, 7, leds_state_array);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void fill_state_time(String time)                                                                                                                                         //  ACABADO
    {
        Log.i(TAG, "Escribimos el tiempo entre estados: " + time);
        char [] char_time = time.toCharArray();
        String time_to_show = Character.toString(char_time[0]);
        Log.i(TAG, "El tiempo a mostrar es: " + time_to_show);
        state_time.setText("Tiempo entre estados " + time_to_show +"ms");
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________________ CONTROL  THE  BUTTONS _________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void go_view_cycle_on_work()                                                                                                                                              //  ACABADO
    {
        //Primero creamos el intent que cre el acceso a la activity que queremos ir, luego ponemos en comun el argumento que vamos a necesitar en la otra activity y por utimo, la lanzamos
        Intent view_cycle_on_work = new Intent(Device_View.this, View_Cycle_On_Work.class);//desde la ventana en que estoy, a la que quiero llegar
        view_cycle_on_work.putExtra("CYCLE_NAME", cycle_on_work_name);
        startActivity(view_cycle_on_work);//llamo a la otra ventana usando el parámetro intent que nos lleva de una a otra, como si de un camino se tratase
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void go_conf_work_cycle()                                                                                                                                                 //  ACABADO
    {
        keep_reading = false;
        Intent conf_work_cycle = new Intent(Device_View.this, Conf_Work_Cycle.class);//desde la ventana en que estoy, a la que quiero llegar
        conf_work_cycle.putExtra("DEVICE", device);    // ponemos en común los datos del dispositivo bluetooth seleccionado para poder hacer uso del mismo y escribir sus caracteristicas
        startActivityForResult(conf_work_cycle, 112233);//llamo a la otra ventana usando el parámetro intent que nos lleva de una a otra, como si de un camino se tratase
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void go_accessible_devices()                                                                                                                                              //  ACABADO
    {
        gatt_to_use.close();
        setResult(RESULT_OK);
        finish();
    }

    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void help_of_this_activity()
    {
        //AMBOS CODIGOS SON VALIDOS, PERO VAMOS A USAR EL SUPERIOR PARA GANAR LEGIBILIDAD EN EL CODIGO

        Intent youtube_help = new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v=9-3OCc5g5oE"));//desde la ventana en que estoy, a la que quiero llegar
        startActivity(youtube_help);
        //startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v=9-3OCc5g5oE")));
        // Toast.makeText(this, "Hemos pasado por la parte de ir a youtube",Toast.LENGTH_SHORT).show(); // Los "toast" que uso son solo para verificacion de por donde llega el codigo en ejecucion
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*___________________________________________________________________________ METODH  ON  RESULT ___________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        Log.i(TAG, "onActivityResult");
        switch (requestCode)
        {
            case 112233:
            {
                switch (resultCode)
                {
                    case RESULT_OK:
                        {
                            Log.i(TAG, "onActivityResult --> Volvemos desde configurar un nuevo trabajo. El resultado era OK");
                            //Como se ha añadido correctamente un estado en el ciclo de trabajo, debemos recargar la vista en el linearlayout. Para ello, primero hemos de limpiarlo
                            take_data_for_new_conf(data);

                            getCharacteristicFromUUID(Constants.UUID_NAME_TIME_WRITE).setValue(time_name);
                            getCharacteristicFromUUID(Constants.UUID_STATE_WRITE).setValue(cycle);
                            gatt_to_use.writeCharacteristic(getCharacteristicFromUUID(Constants.UUID_NAME_TIME_WRITE));
                            Log.i(TAG, "onActivityResult --> Hemos acabado el envio !! ");
                        }
                        break;
                    case RESULT_CANCELED:
                        keep_reading = true;
                        gatt_to_use.writeCharacteristic(getCharacteristicFromUUID(Constants.UUID_NAME_TIME_WRITE));
                        Log.i(TAG, "onActivityResult --> Volvemos desde configurar un nuevo trabajo. No se ha decidido configurar un nuevo trabajo");
                }
            }
//            case 012345:
//            {
//                Log.i(TAG, "onActivityResult --> Volvemos desde ver el ciclo de trabajo actual");
//                switch (resultCode)
//                {
//                    case RESULT_OK:
//                        Log.i(TAG, "Se ha visualizado correctamente el ciclo de trabajo actual");
//                        break;
//                    case RESULT_CANCELED:
//                        Log.i(TAG, "NO se ha visualizado correctamente el ciclo de trabajo actual");
//                }
//            }
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_____________________________________________________________________ ELEMENT  VISIBILITY  MANAGEMENT ____________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void visibility_of_elements()                                                                                                                                              // ACABADO
    {
        Log.i(TAG, "Gestionamos la visibilidad de los elementos y el color de imageView refefrente a la conexión");

        state_device.setBackgroundColor(getResources().getColor(R.color.connected));

        //gestiono la visibilidad de los elementos
        state_time.setVisibility(View.VISIBLE);

        conf_device.setVisibility(View.VISIBLE);
        cycle_on_work.setVisibility(View.VISIBLE);

        led1.setVisibility(View.VISIBLE);
        led2.setVisibility(View.VISIBLE);
        led3.setVisibility(View.VISIBLE);
        led4.setVisibility(View.VISIBLE);
        led5.setVisibility(View.VISIBLE);
        led6.setVisibility(View.VISIBLE);
        led7.setVisibility(View.VISIBLE);
        led8.setVisibility(View.VISIBLE);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void invisibility_for_elements()                                                                                                                                           // ACABADO
    {
        Log.i(TAG, "Gestionamos la INvisibilidad de los elementos y el color de imageView refefrente a la conexión");

        state_device.setBackgroundColor(getResources().getColor(R.color.disconnected));

        state_time.setVisibility(View.INVISIBLE);
        state_time.setText(" ");
        conf_device.setVisibility(View.INVISIBLE);
        cycle_on_work.setVisibility(View.INVISIBLE);
        cycle_on_work.setText(" ");

        led1.setBackgroundColor(getResources().getColor(R.color.button_gone));
        led2.setBackgroundColor(getResources().getColor(R.color.button_gone));
        led3.setBackgroundColor(getResources().getColor(R.color.button_gone));
        led4.setBackgroundColor(getResources().getColor(R.color.button_gone));
        led5.setBackgroundColor(getResources().getColor(R.color.button_gone));
        led6.setBackgroundColor(getResources().getColor(R.color.button_gone));
        led7.setBackgroundColor(getResources().getColor(R.color.button_gone));
        led8.setBackgroundColor(getResources().getColor(R.color.button_gone));

        led1.setVisibility(View.INVISIBLE);
        led2.setVisibility(View.INVISIBLE);
        led3.setVisibility(View.INVISIBLE);
        led4.setVisibility(View.INVISIBLE);
        led5.setVisibility(View.INVISIBLE);
        led6.setVisibility(View.INVISIBLE);
        led7.setVisibility(View.INVISIBLE);
        led8.setVisibility(View.INVISIBLE);
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_________________________________________________________________________ PREPARE  THE  ACTIVITY _________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    //Este modulo se encarga de tomar los datos que se envian desde la activity padre y ponerlos donde debe
    private void take_data_for_new_conf(Intent data_from_cwc)                                                                                                                         //  ACABADO
    {
        Log.i(TAG, "onActivityResult --> Recogemos los datos que se nos pasan desde la activity configurar_nuevo_ciclo_de_trabajo" );
        time_name = "";
        cycle = "";

        time_name = data_from_cwc.getStringExtra("TIME_NAME");
        cycle = data_from_cwc.getStringExtra("CYCLE");

        Log.i(TAG, "onActivityResult --> Los datos recibidos son: \n" + time_name +"\n" + cycle );

        // En caso de que no hayamos podido tomar el valor del dipositivos que nos pasa el activity padre, lo mostramos en el Logcat para la depuracion de codigo
        Log.i(TAG, device != null ? device.getAddress() : "No se ha podido recibir");
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    //Este modulo se encarga de tomar los datos que se envian desde la activity padre y ponerlos donde debe
    private void take_data()                                                                                                                                                          //  ACABADO
    {
        Log.i(TAG, "Recogemos los datos que se nos pasan desde la activity padre (Device_View)" );
        device = getIntent().getParcelableExtra("DEVICE");

        device_name.setText(device.getName());

        // En caso de que no hayamos podido tomar el valor del dipositivos que nos pasa el activity padre, lo mostramos en el Logcat para la depuracion de codigo
        Log.i(TAG, device != null ? device.getAddress() : "No se ha podido recibir");
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void prepare_buttons()                                                                                                                                                      //ACABADO
    {
        // Defino los metodos sobre los botones
        conf_device.setOnClickListener(this);
        cycle_on_work.setOnClickListener(this);
        back.setOnClickListener(this);
        help.setOnClickListener(this);

        //Método de gestion del cambio de estado de un ToggleButton y lo que provoca
        connection.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener()
        {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean connection_state)
            {
                if (connection_state)
                {
                    connection.setTextOn("Conectando...");
//                    ask_for_connection();

                    BluetoothManager manager = (BluetoothManager) getSystemService(BLUETOOTH_SERVICE);
                    final BluetoothAdapter adapter = manager.getAdapter();
                    adapter.startDiscovery();
                    broadcastReceiver = new BroadcastReceiver()
                    {
                        @Override
                        public void onReceive(Context context, Intent intent)
                        {
                            //el elemento de escucha puede recibir distintos tipos de avisos, así que tenemos que discernir cuando el aviso significa "dispositivo descubierto"
                            String action = intent.getAction();
                            if (action.equals(BluetoothDevice.ACTION_FOUND)) //si lo escuchado es un intento de encontrar...
                            {
                                BluetoothDevice actual_device = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
                                if (actual_device.getAddress().equals(device.getAddress()))
                                {
                                    readStuff(adapter, actual_device);
                                }
                            }
                        }
                    };
                    IntentFilter filter = new IntentFilter(BluetoothDevice.ACTION_FOUND);
                    registerReceiver(broadcastReceiver, filter);

                } else
                {
                    gatt_to_use.close();
                    invisibility_for_elements();
                    Log.i(TAG, "Me estoy desconectando del dispositivo");
                }
            }
        });
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void init()                                                                                                                                                               //  ACABADO
    {
        device_name = findViewById(R.id.tv_device_name_dv);
        state_time = findViewById(R.id.tv_state_time_dv);

        conf_device = findViewById(R.id.bt_conf_work_cycle_dv);
        cycle_on_work = findViewById(R.id.bt_cycle_on_work_dv);

        connection = findViewById(R.id.tb_connection_dv);

        back = findViewById(R.id.bt_back_dv);
        help = findViewById(R.id.bt_help_dv);

        state_device = findViewById(R.id.iv_state_device_dv);

        led1 = findViewById(R.id.iv_led_1_dv);
        led2 = findViewById(R.id.iv_led_2_dv);
        led3 = findViewById(R.id.iv_led_3_dv);
        led4 = findViewById(R.id.iv_led_4_dv);
        led5 = findViewById(R.id.iv_led_5_dv);
        led6 = findViewById(R.id.iv_led_6_dv);
        led7 = findViewById(R.id.iv_led_7_dv);
        led8 = findViewById(R.id.iv_led_8_dv);

        prepare_buttons();

        characteristics = new ArrayList<>();

        take_data();
    }
}