package com.example.tfg;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class View_Cycle_On_Work  extends Activity implements View.OnClickListener
{

    private static final String TAG = View_Cycle_On_Work.class.getName();

    //Variables referentes a los elementos visuales de la activity
    TextView work_cycle_name;
    ImageButton help, back;
    LinearLayout states_work_cycle;

    //Variable que usaré para trabajar con los estados del ciclo de trabajo
    ArrayList<String> states;

    // Otras variables
    String name_cycle_on_work, file_to_use;
    String [] files; //creo una array "files" del tipo "String" en la que guardaré TODOS los nombres de los ficheros encontrados

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________ BASE  METHODS  OF  THE  ACTIVITY ______________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.conf_work_cycle);
        init();

        work_cycle_name.setText(name_cycle_on_work);

        fill_linear_layout();
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    @Override
    public void onClick(View view)                                                                                                                                                   //  ACABADO
    {
        switch (view.getId())
        {
            case R.id.bt_help_ad:
                help_of_this_activity();
                break;
            case R.id.bt_back_dv:
                go_device_view();
            default:
                break;
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*______________________________________________________________________ USE  THE  LINEAR  LAYOUT __________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    /*Este modulo se encarga de poblar le linear layout (rellenarlo, fill) desde los datos del la lista que se carga con anterioridad desde el fichero de texto  */
    private void fill_linear_layout()
    {
        file_to_use = name_cycle_on_work + ".txt";
        Log.i(TAG, "Rellenamos el linearlayout con los datos del fichero: " + file_to_use);
        //Primero he de cargar el fichero en la lista desde la que lo cargaré en la vista
        charge_file_to_list();

        //ahora, he de poblar el linear layout, de modo que....
        for(int i = 0 ; i < states.size() ; i++)
        {
            // Primero creamos una vista para cada uno de los elementos (item) encontrados, bajo la forma definida en item_ll_list_work_cycles. para ello, primero definimos los elementos de ese layout
            final View view = View.inflate(View_Cycle_On_Work.this, R.layout.item_ll_view_state, null);
            TextView state_text = view.findViewById(R.id.text_state_number_ll_vs);
            TextView index = view.findViewById(R.id.index_ll_vs);
            TextView state_number = view.findViewById(R.id.number_state_ll_vs);
            ImageView led_1 = view.findViewById(R.id.led1_ll_vs);
            ImageView led_2 = view.findViewById(R.id.led2_ll_vs);
            ImageView led_3 = view.findViewById(R.id.led3_ll_vs);
            ImageView led_4 = view.findViewById(R.id.led4_ll_vs);
            ImageView led_5 = view.findViewById(R.id.led5_ll_vs);
            ImageView led_6 = view.findViewById(R.id.led6_ll_vs);
            ImageView led_7 = view.findViewById(R.id.led7_ll_vs);
            ImageView led_8 = view.findViewById(R.id.led8_ll_vs);

            //editamos los valores del item en el linear layout con los que acabamos de encontrar en el dispositivo bluetooth que se ha encontrado
            index.setText(String.valueOf(i));
            state_text.setText("Estado Nº ");
            state_number.setText(String.valueOf(i));

            String state = states.get(i);
            char [] char_state = state.toCharArray();
            charge_state_on_linear_layout(led_1, led_2, led_3, led_4, led_5, led_6, led_7, led_8, char_state);

            //añadimos la vista creada al linear layout como un nuevo elemento
            runOnUiThread(new Runnable()
            {
                @Override
                public void run()
                {
                    states_work_cycle.addView(view);
                }
            });
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*______________________________________________________________________ WORK  WITH THE  IMAGEVIEWS ________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void charge_state_on_linear_layout(ImageView led_1, ImageView led_2, ImageView led_3, ImageView led_4, ImageView led_5, ImageView led_6, ImageView led_7, ImageView led_8, char [] state_to_send)                                                                                                                                                      //ACABADO
    {
        Log.i(TAG, "Cargamos las vistas de los led");
        set_image_view(led_1, 0, state_to_send);
        set_image_view(led_2, 1, state_to_send);
        set_image_view(led_3, 2, state_to_send);
        set_image_view(led_4, 3, state_to_send);
        set_image_view(led_5, 4, state_to_send);
        set_image_view(led_6, 5, state_to_send);
        set_image_view(led_7, 6, state_to_send);
        set_image_view(led_8, 7, state_to_send);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void set_image_view(final ImageView to_check, final int led_index, char [] actual_state_to_show)                                                                           //ACABADO
    {
        Log.i(TAG, "Cargamos la imagen del led: " + led_index);
        if(actual_state_to_show[led_index] == '1')
        {
            to_check.setBackgroundColor(getResources().getColor(R.color.button_ON));
        }
        else
        {
            to_check.setBackgroundColor(getResources().getColor(R.color.button_OFF));
        }
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_____________________________________________________________________________ USE  THE  FILE _____________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    /*Este modulo se encarga de hacer una lista desde la lectura del fichero que se nos indica que debemos mostrar por pantalla desde la activity anterior  */
    private void charge_file_to_list()                                                                                                                                               //  ACABADO
    {
        files = null;  //limpiamos el array de ficheros que hay en la app para poder actualiarlo
        files = getApplicationContext().fileList();    // actualizamos los ficheros que hay en la app

        states.clear();// Vaciamos la lista de estados

        file_to_use = name_cycle_on_work + ".txt";
        if(file_exist(files, file_to_use))
        {
            Log.i(TAG, "Ahora vamos a cargar los datos del fichero en una lista para poder usarlos" );
            //Toast.makeText(getApplicationContext(),"Existe el archivo", Toast.LENGTH_SHORT).show();
            try
            {
                //Toast.makeText(getApplicationContext(),"Hemos logrado entrar dentro del try", Toast.LENGTH_SHORT).show();

                //sabemos que existe el fichero, asi que trabajamos con el
                InputStreamReader file_on_read = new InputStreamReader(openFileInput(file_to_use)); //creo una variable de acceso al fichero
                BufferedReader buf_reader = new BufferedReader(file_on_read);  // Creo un lector para nuestro archivo
                String state_line = buf_reader.readLine(); // leo el archivo linea a linea, una linea por vez

                //Toast.makeText(getApplicationContext(),"La primera linea del archivo almacena: " + state_line, Toast.LENGTH_LONG).show();

                while(state_line != null)   // en caso de que el archivo no esté vacío, almacenamos lo que acabamos de leer detrás de lo que ya estaba y pasamos a la siguiente linea
                {
                    states.add(state_line); //añadimos el estado a la lista de estados
                    state_line = buf_reader.readLine(); // ... paso a leer la siguiente línea, y así, hasta que acabemos con todo el fichero a leer, hasta encontrar una linea vacía
                }

                //Para indicar que dejamos ya de leer, cerramos primero nuestro lector, y después nuestro archivo
                buf_reader.close();
                file_on_read.close();
            }
            catch (IOException e)
            {
                Log.i(TAG,"Error al intentar leer el fichero " + file_to_use);
                Toast.makeText(getApplicationContext(),"El fichero no existe", Toast.LENGTH_SHORT).show();
            }
        }
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    /* Este modulo se encarga de encontrar el fichero que se desea cargar (en caso de existir). Este módulo no requiere de llaves por tratarse de un módulo booleano, lo que permite obviar las
    llaves de apertura y cierre  */
    private boolean file_exist(String [] accessible_files, String request_file)                                                                                                      //  ACABADO
    {
        Log.i(TAG, "Buscamos el fichero de texto " + name_cycle_on_work);
        for(int i = 0; i< accessible_files.length; i++) //el método length nos devuelve el tamaño del array de strings "accesible_files"
            if (request_file.equals(accessible_files[i]))   // en caso de la variable "request_file" sea igual al string almacenado en la posicion [i] de accessible_files...
                return true;    // devolver "true"
        return false;   // en caso contrario, devolver "false"
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*__________________________________________________________________________ CONTROL  THE  BUTTONS _________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    private void go_device_view()                                                                                                                                                    //  ACABADO
    {
        Log.i(TAG, "Volvemos a la activity padre");
        //usamos este método para volver a la activity anterior y a la par, eliminar esta de la pila (stack)
        finish();
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void help_of_this_activity()
    {
        //AMBOS CODIGOS SON VALIDOS, PERO VAMOS A USAR EL SUPERIOR PARA GANAR LEGIBILIDAD

        Intent youtube_help = new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v=9-3OCc5g5oE"));//desde la ventana en que estoy, a la que quiero llegar
        startActivity(youtube_help);
        //startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.youtube.com/watch?v=9-3OCc5g5oE")));
        // Toast.makeText(this, "Hemos pasado por la parte de ir a youtube",Toast.LENGTH_SHORT).show(); // Los "toast" que uso son solo para verificacion de por donde llega el codigo en ejecucion
    }

    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/
    /*_________________________________________________________________________ PREPARE  THE  ACTIVITY _________________________________________________________________________________________*/
    /*_++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++_*/

    //Este modulo se encarga de tomar los datos que se envian desde la activity padre
    private void take_data()                                                                                                                                                         //  ACABADO
    {
        Log.i(TAG, "Recogemos los datos que se nos pasan desde la activity padre (Device_View)" );
        name_cycle_on_work = getIntent().getStringExtra("CYCLE_NAME");

        Log.i(TAG, "Los datos recogidos son: nombre del ciclo de trabajo = " + name_cycle_on_work);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void prepare_buttons()                                                                                                                                                    //  ACABADO
    {
        Log.i(TAG, "Preparamos los botones");
        back.setOnClickListener(this);
        help.setOnClickListener(this);
    }
    /*_________________________________________________________________________________________________________________________________________________________________________________________*/

    private void init()                                                                                                                                                              //  ACABADO
    {

        Log.i(TAG, "Inicializamos la activity");
        states_work_cycle = findViewById(R.id.ll_states_cow);

        work_cycle_name = findViewById(R.id.tv_work_cycle_name_cow);

        back = findViewById(R.id.bt_back_cwc);
        help = findViewById(R.id.bt_help_cwc);

        prepare_buttons();

        states = new ArrayList<>();

        // Vaciamos el linear layout en caso de que hubiese alguna vista
        states_work_cycle.removeAllViewsInLayout();

        //tomamos los datos que se nos pasa desde la activity padre
        take_data();
    }
}
